:: -------------------------------------------------------------------
:: 
:: update-links.bat -- Delete orphaned links and create new ones.
::
:: 
:: author : Mathias Michaelis <michaelis@tcnet.ch>
:: date   : May 4, 2006
:: version: 0.6.13
::
:: Copyright (c) 2006 by Mathias Michaelis, <michaelis@tcnet.ch>
::
:: -------------------------------------------------------------------
::
:: Permission is granted to copy, distribute and/or modify this document
:: under the terms of the GNU Free Documentation License, Version 1.2
:: or any later version published by the Free Software Foundation;
:: with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
:: Texts.  A copy of the license is included in the file LICENSE.TXT
::
::
:: Acknowledgments
:: ---------------
::
:: See file README.TXT in this directory. Thanks to all who advised me,
:: gave me some hints, sent me some patches or encouraged me to go on!
::
@echo off
setlocal ENABLEEXTENSIONS
set PATH=%CD%\gnuwin32\bin;%PATH%

::
:: Warn about taking a long time
::
echo Status: Please wait. This may take a long time ...
echo         When the process is completed, `Status: Complete.' will be displayed.

::
:: Searching for orphaned links (only for the first time)
::
if not exist gnuwin32\bin\ls.exe goto delete_orphan_links_slow
if not exist gnuwin32\bin\sed.exe goto delete_orphan_links_slow
if exist "gnuwin32\Start Menu\gnuwin32.lnk" goto delete_orphan_links_slow
echo Status: Searching for orphan links ...
gnuwin32\bin\ls -lgGRU gnuwin32 | gnuwin32\bin\sed -n "/:$/{s//\//;h};/l[^ ]* \+[^ ]\+ \+[^ ]\+ [^ ]\+ \+[^ ]\+ \+\([^ ]\+\) -> \(.*\)/{s//\1 -> \2/;G;s/\([^\n]*\)\n\(.*\)/\2\1/;s/\//\\/g;p}" >orphan_links.txt

::
:: Delete orphan links (fast)
::
echo Status: Deleting orphaned links ...
gnuwin32\bin\sed -n "s/\(.*\) -> .*/del \/f \d034\1\d034/p" orphan_links.txt >orphan_links.bat
call orphan_links.bat
del orphan_links.bat
goto recreate_links

::
:: Delete orphan links (slow, because lnk-files must be searched)
::
:delete_orphan_links_slow
echo Status: Deleting orphaned links ...
echo orphan >gnuwin32\bin\orphan.lnk
del /F /S /Q gnuwin32\*.lnk >nul

::
:: Create new shortcuts
::
:recreate_links
echo Status: Creating new shortcuts ...

if exist "gnuwin32\bin\popt.dll.lnk" del "gnuwin32\bin\popt.dll.lnk"
if exist "gnuwin32\bin\awk.exe.lnk" del "gnuwin32\bin\awk.exe.lnk"
if exist "gnuwin32\bin\red.exe.lnk" del "gnuwin32\bin\red.exe.lnk"

if exist "gnuwin32\bin\popt1.dll" if not exist "gnuwin32\bin\popt.dll" copy "gnuwin32\bin\popt1.dll" "gnuwin32\bin\popt.dll" >nul
if exist "gnuwin32\bin\gawk.exe" if not exist "gnuwin32\bin\awk.exe" copy "gnuwin32\bin\gawk.exe" "gnuwin32\bin\awk.exe" >nul
if exist "gnuwin32\bin\ed.exe" if not exist "gnuwin32\bin\red.exe" copy "gnuwin32\bin\ed.exe" "gnuwin32\bin\red.exe" >nul

if not exist gnuwin32\bin\mkshortcut.exe goto mkshortcut_not_existing
if not exist orphan_links.txt goto recreate_links_adhoc

sed -n "s/\(.*\)\.lnk -> [A-Za-z]:\\Program Files\\[^\]\+\\\(.*\)/if exist \d034gnuwin32\\\2\d034 if not exist \d034\1\d034 gnuwin32\\bin\\mkshortcut -n \d034\1.lnk\d034 \d034gnuwin32\\\2\d034/p" orphan_links.txt >orphan_links.bat
call orphan_links.bat
del orphan_links.bat
del orphan_links.txt
goto create_start_menu

:recreate_links_adhoc
if exist "gnuwin32\man\cat3\dither.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\bwdithermap.3.txt.lnk" "gnuwin32\man\cat3\dither.3.txt"
if exist "gnuwin32\man\cat3\gettext.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dcgettext.3.txt.lnk" "gnuwin32\man\cat3\gettext.3.txt"
if exist "gnuwin32\man\cat3\ngettext.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dcngettext.3.txt.lnk" "gnuwin32\man\cat3\ngettext.3.txt"
if exist "gnuwin32\man\cat3\gettext.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dgettext.3.txt.lnk" "gnuwin32\man\cat3\gettext.3.txt"
if exist "gnuwin32\man\cat3\dither.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\ditherbw.3.txt.lnk" "gnuwin32\man\cat3\dither.3.txt"
if exist "gnuwin32\man\cat3\dither.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dithergb.3.txt.lnk" "gnuwin32\man\cat3\dither.3.txt"
if exist "gnuwin32\man\cat3\dither.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dithermap.3.txt.lnk" "gnuwin32\man\cat3\dither.3.txt"
if exist "gnuwin32\man\cat3\ngettext.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\dngettext.3.txt.lnk" "gnuwin32\man\cat3\ngettext.3.txt"
if exist "gnuwin32\man\cat3\isinf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\finite.3.txt.lnk" "gnuwin32\man\cat3\isinf.3.txt"
if exist "gnuwin32\man\cat3\wprintf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\fwprintf.3.txt.lnk" "gnuwin32\man\cat3\wprintf.3.txt"
if exist "gnuwin32\man\cat3\hilbert.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\hilbert_c2i.3.txt.lnk" "gnuwin32\man\cat3\hilbert.3.txt"
if exist "gnuwin32\man\cat3\hilbert.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\hilbert_i2c.3.txt.lnk" "gnuwin32\man\cat3\hilbert.3.txt"
if exist "gnuwin32\man\cat3\isinf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\isnan.3.txt.lnk" "gnuwin32\man\cat3\isinf.3.txt"
if exist "gnuwin32\man\cat3\j0.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\j1.3.txt.lnk" "gnuwin32\man\cat3\j0.3.txt"
if exist "gnuwin32\man\cat3\j0.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\jn.3.txt.lnk" "gnuwin32\man\cat3\j0.3.txt"
if exist "gnuwin32\man\cat3\dither.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\make_square.3.txt.lnk" "gnuwin32\man\cat3\dither.3.txt"
if exist "gnuwin32\man\cat3\rle_get_set.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_debug.3.txt.lnk" "gnuwin32\man\cat3\rle_get_set.3.txt"
if exist "gnuwin32\man\cat3\rle_putcom.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_delcom.3.txt.lnk" "gnuwin32\man\cat3\rle_putcom.3.txt"
if exist "gnuwin32\man\cat3\rle_getraw.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_freeraw.3.txt.lnk" "gnuwin32\man\cat3\rle_getraw.3.txt"
if exist "gnuwin32\man\cat3\rle_get_set.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_get_error.3.txt.lnk" "gnuwin32\man\cat3\rle_get_set.3.txt"
if exist "gnuwin32\man\cat3\rle_get_set.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_get_setup.3.txt.lnk" "gnuwin32\man\cat3\rle_get_set.3.txt"
if exist "gnuwin32\man\cat3\rle_get_set.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_get_setup_ok.3.txt.lnk" "gnuwin32\man\cat3\rle_get_set.3.txt"
if exist "gnuwin32\man\cat3\rle_putcom.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_getcom.3.txt.lnk" "gnuwin32\man\cat3\rle_putcom.3.txt"
if exist "gnuwin32\man\cat3\rle_open_f.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_open_f_noexit.3.txt.lnk" "gnuwin32\man\cat3\rle_open_f.3.txt"
if exist "gnuwin32\man\cat3\rle_put_init.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_put_setup.3.txt.lnk" "gnuwin32\man\cat3\rle_put_init.3.txt"
if exist "gnuwin32\man\cat3\rle_raw_free.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_raw_alloc.3.txt.lnk" "gnuwin32\man\cat3\rle_raw_free.3.txt"
if exist "gnuwin32\man\cat3\rle_row_free.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\rle_row_alloc.3.txt.lnk" "gnuwin32\man\cat3\rle_row_free.3.txt"
if exist "gnuwin32\man\cat3\wprintf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\swprintf.3.txt.lnk" "gnuwin32\man\cat3\wprintf.3.txt"
if exist "gnuwin32\man\cat3\compface.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\uncompface.3.txt.lnk" "gnuwin32\man\cat3\compface.3.txt"
if exist "gnuwin32\man\cat3\wprintf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\vfwprintf.3.txt.lnk" "gnuwin32\man\cat3\wprintf.3.txt"
if exist "gnuwin32\man\cat3\wprintf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\vswprintf.3.txt.lnk" "gnuwin32\man\cat3\wprintf.3.txt"
if exist "gnuwin32\man\cat3\wprintf.3.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat3\vwprintf.3.txt.lnk" "gnuwin32\man\cat3\wprintf.3.txt"
if exist "gnuwin32\man\cat1\bzdiff.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\bzcmp.1.txt.lnk" "gnuwin32\man\cat1\bzdiff.1.txt"
if exist "gnuwin32\man\cat1\bzgrep.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\bzegrep.1.txt.lnk" "gnuwin32\man\cat1\bzgrep.1.txt"
if exist "gnuwin32\man\cat1\bzgrep.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\bzfgrep.1.txt.lnk" "gnuwin32\man\cat1\bzgrep.1.txt"
if exist "gnuwin32\man\cat1\bzmore.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\bzless.1.txt.lnk" "gnuwin32\man\cat1\bzmore.1.txt"
if exist "gnuwin32\man\cat1\gzip.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\gunzip.1.txt.lnk" "gnuwin32\man\cat1\gzip.1.txt"
if exist "gnuwin32\man\cat1\lesspipe.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\lessfile.1.txt.lnk" "gnuwin32\man\cat1\lesspipe.1.txt"
if exist "gnuwin32\man\cat1\compface.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\uncompface.1.txt.lnk" "gnuwin32\man\cat1\compface.1.txt"
if exist "gnuwin32\man\cat1\gzip.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\zcat.1.txt.lnk" "gnuwin32\man\cat1\gzip.1.txt"
if exist "gnuwin32\man\cat1\zdiff.1.txt" gnuwin32\bin\mkshortcut -n "gnuwin32\man\cat1\zcmp.1.txt.lnk" "gnuwin32\man\cat1\zdiff.1.txt"
goto create_start_menu

::
:: If mkshortcut doesn't exist, report it.
::
:mkshortcut_not_existing
if exist orphan_links.txt del orphan_links.txt
echo Status: Warning! mkshortcut.exe doesn't exist. Too bad, because it is needed
echo         to recreate the above deleted shortcuts and most of all to create a
echo         reasonable start menu. If you don't need that, all is ok. Else please
echo         download and install the cygutils packages.
goto bye

::
:: Creating start menu entries.
::
:create_start_menu
echo Status: Creating Start menu entries ...
if exist "gnuwin32\Start Menu" rmdir /s /q "gnuwin32\Start Menu"
mkdir "gnuwin32\Start Menu"
mkdir "gnuwin32\Start Menu\doc"
mkdir "gnuwin32\Start Menu\man"
mkdir "gnuwin32\Start Menu\chm"
mkdir "gnuwin32\Start Menu\hlp"

::
:: Link to start a cmd shell with proper environment set
::
if not exist "gnuwin32\bin\set_gnuwin32.bat" goto links_to_pdf
gnuwin32\bin\mkshortcut -a "/K """"""%CD%\gnuwin32\bin\set_gnuwin32.bat""" -s gnuwin32"""" -i "%CD%\gnuwin32\gnuwin32.ico" -d "Environment for gnuwin32 tools" -w "%CD:*:=%\gnuwin32" -n "gnuwin32\Start Menu\gnuwin32.lnk" "%windir:*:=%\system32\cmd.exe"

if not exist gnuwin32\bin\sed.exe goto links_to_pdf
gnuwin32\bin\sed.exe "s/set GNUWIN32=.*/set GNUWIN32=%CD:\=\\%\\gnuwin32/g" gnuwin32\bin\set_gnuwin32.bat >gnuwin32\bin\set_gnuwin32.tmp
del gnuwin32\bin\set_gnuwin32.bat
ren gnuwin32\bin\set_gnuwin32.tmp set_gnuwin32.bat

:: 
:: Links to PDFs
::
:links_to_pdf
echo Status: Creating links to PDFs ...
for /r gnuwin32\doc %%a in (*.pdf) do (
	gnuwin32\bin\mkshortcut -n "gnuwin32\Start Menu\doc\%%~na.lnk" "%%~pnxa"
)

::
:: Links to man pages (PDFs).
::
echo Status: Creating links to man pages (.pdf) ...
for /r gnuwin32\man\pdf %%a in (*.pdf) do (
	gnuwin32\bin\mkshortcut -n "gnuwin32\Start Menu\man\%%~na.lnk" "%%~pnxa"
)

::
:: Links to chm (Compiled HTML) files.
::
echo Status: Creating links to HTML Help (.chm) files ...
for /r gnuwin32\doc %%a in (*.chm) do (
	gnuwin32\bin\mkshortcut -n "gnuwin32\Start Menu\chm\%%~na.lnk" "%%~pnxa"
)

::
:: Links to hlp (Windows Help) files.
::
echo Status: Creating links to Windows Help (.hlp) files ...
for /r gnuwin32\doc %%a in (*.hlp) do (
	gnuwin32\bin\mkshortcut -n "gnuwin32\Start Menu\hlp\%%~na.lnk" "%%~pnxa"
)

::
:: Tidy up
::
:bye
echo Status: Complete.
echo Please rename and copy the `Start Menu' folder to an appropriate place.
endlocal
